<?php


	
	/**
	* Check for the existence of WooCommerce and any other requirements
	*/
	function antsroute_check_requirements() {
	    if ( is_plugin_active( 'woocommerce/woocommerce.php' ) ) {
	        return true;
	    } else {
	        add_action( 'admin_notices', 'antsroute_missing_wc_notice' );
	        return false;
	    }
	}
	
	
	/**
	* Display a message advising WooCommerce is required
	*/
	function antsroute_missing_wc_notice() { 
	    $class = 'notice notice-error';
	    $message = __( 'AntsRoute requires WooCommerce to be installed and active.', 'ants-route' );
	 
	    printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $class ), esc_html( $message ) ); 
	}
	



	function pw_load_scripts() {
		wp_enqueue_script('settings-js', '/wp-content/plugins/Antsroute/assets/js/settings.js');
	}
	add_action('admin_enqueue_scripts', 'pw_load_scripts');





	// Add fields in order admin form for delivery date and antsroute state
	add_action('wc_add_order_item_meta','add_order_meta_field',1,2);


	function add_order_meta_field($item_id, $values)
		{
        wc_add_order_item_meta($item_id,'antsroute_delivery_date','');  
        wc_add_order_item_meta($item_id,'antsroute_state','');  
  		}	
  		
	add_action( 'woocommerce_admin_order_data_after_order_details', 'add_order_admin_custom_field' );
 
	function add_order_admin_custom_field( $order )
		{  	
		echo '<div><br class="clear" /><br class="clear" /><b>' . __( 'Delivery date (from  AntsRoute)', 'ants-route' ) . ': </b> '.get_post_meta( $order->get_id(), 'antsroute_delivery_date', true ).'</div>
			 <div><b>' . __( 'State (from  AntsRoute)', 'ants-route' ) . ': </b> '.get_post_meta( $order->get_id(), 'antsroute_state', true ).'</div>';
			 
		}
	
	// plugin activation

	function create_log_table_on_activation()
		{		
		// create the custom table
		global $wpdb;
		
		$charset_collate = $wpdb->get_charset_collate();
		
		$sql = "CREATE TABLE ".$wpdb->prefix."antsroute_logs (
				    id bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
				    date_send DATETIME NOT NULL,
				    date_receive DATETIME NOT NULL,
				    response_data TEXT NOT NULL,
				    url VARCHAR(255) NOT NULL,
				    method VARCHAR(255) NOT NULL,
				    params TEXT NOT NULL,
				    http_code INT(3) NULL DEFAULT NULL,
					PRIMARY KEY  (id)
				) $charset_collate;";

	
		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );
		}

	// plugin desactivation

	function delete_log_table_on_deactivation()
		{		
		// create the custom table
		global $wpdb;
		
		
		$sql = "DROP TABLE IF EXISTS ".$wpdb->prefix."antsroute_logs";
	
		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		$wpdb->query( $sql );
		$wpdb->flush();
		}
		
	register_activation_hook( ABSPATH . 'wp-content/plugins/Antsroute/antsroute.php', 'create_log_table_on_activation' );
	register_deactivation_hook( ABSPATH . 'wp-content/plugins/Antsroute/antsroute.php', 'delete_log_table_on_deactivation' );

	
?>