<?php

 
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

if ( ! class_exists( 'WC_Settings_AntsRoute' ) ) :

/**
 * Settings class
 *
 * @since 1.0.0
 */
 
	function my_plugin_add_settings() 
		{ 
		class WC_Settings_AntsRoute extends WC_Settings_Page 
			{
			public function __construct() {
			        
			    $this->id    = 'antsroute';
			    $this->label = __( ' AntsRoute', 'ants-route' );
			    $this->target = '/';
			            
			    add_filter( 'woocommerce_settings_tabs_array',        array( $this, 'add_settings_page' ), 20 );
			    add_action( 'woocommerce_settings_' . $this->id,      array( $this, 'output' ) );
			    add_action( 'woocommerce_settings_save_' . $this->id, array( $this, 'save' ) );
			    
			    // only add this if you need to add sections for your settings tab
			    add_action( 'woocommerce_sections_' . $this->id,      array( $this, 'output_sections' ) );
				}

			public function get_sections() {
			        
			    $sections = array(
			        'antsroute_general_setting'         => __(  'General settings', 'ants-route' ),
			        'antsroute_delivery_setting' => __( 'Delivery settings', 'ants-route' ),
			        'antsroute_pickup_setting' => __( 'Pick_Up', 'ants-route' ),
			        'antsroute_log' => __( 'Log', 'ants-route' ),

			        );
			            
			    return apply_filters( 'woocommerce_get_sections_' . $this->id, $sections );
				}		
	
	
					
			public function get_settings( $current_section = '' ) 
				{		
				global $wpdb;
				// geneate all option lists		

				$order_status_list = wc_get_order_statuses();
			
				$arr_shipping_method = array();
			
				$shipping_zones = WC_Shipping_Zones::get_zones();
				
				foreach($shipping_zones as $zone)
					{
					foreach($zone['shipping_methods'] as $shipping_methods)
						{
						$arr_shipping_method[$shipping_methods->title] = $shipping_methods->title;						
						}
					}
									
				$arr_deadline = array();
			
				for ($i = 1; $i <= TIME_MAX; $i++)
					{
					$arr_deadline[$i] = "$i min.";	
					}


				$arr_time = array();
			
				for ($i = 1; $i <= TIME_MAX; $i++)
					{
					$arr_time[$i] = __('D', 'ants-route' ) . " + $i";	
					}
					
				switch ($current_section)
					{
					case 'antsroute_general_setting':	
										
						$settings = apply_filters( 'antsroute_general_setting', array(

							array(
								'name' => '',
								'type' => 'title',
								'desc' => '',
								'id'   => 'group1_options',
							),
												
							array(
								'type'     => 'select',
								'id'       => 'antsroute_carrier',
								'name'     => __( 'Carrier :', 'ants-route' ),
								'options'  => $arr_shipping_method,
								'class'    => 'wc-enhanced-select',
								'desc_tip' => '',
								'default'  => '',
							),	
																			
							array(
								'type'     => 'select',
								'id'       => 'antsroute_delivery_trigger',
								'name'     => __( 'Delivery Trigger :', 'ants-route' ),
								'options'  => $order_status_list,
								'class'    => 'wc-enhanced-select',
								'desc_tip' => '',
								'default'  => 'wc-processing',
							),							
							
							array(
								'type'     => 'select',
								'id'       => 'antsroute_cancel_trigger',
								'name'     => __( 'Cancel Trigger :', 'ants-route' ),
								'options'  => $order_status_list,
								'class'    => 'wc-enhanced-select',
								'desc_tip' => '',
								'default'  => 'wc-cancelled',
							),							

							array(
						          'title' => __( 'API key', 'ants-route' ),
						          'type' => 'text',
								  'id'   => 'antsroute_api_key',					          
						          'description' => '',
						          'default' => ''
						    ),								

							array(
								'type'     => 'select',
								'id'       => 'antsroute_add_in_order',
								'name'     => __( 'Add in Order :', 'ants-route' ),
								'options'  => array(1 =>  __(  'In the intervention basket', 'ants-route'),
													2 =>  __(  'In the module organize', 'ants-route')),
								'class'    => 'wc-enhanced-select',
								'desc' => __(  'Delivery is planned from this tab', 'ants-route' ),
								'default'  => '',
							),								
							array(
								'type' => 'sectionend',
								'id'   => 'group1_options'
							),							
							
							
						) );
						
						return apply_filters( 'woocommerce_get_settings_' . $this->id, $settings, $current_section );
								
						break;
						
						
					case 'antsroute_delivery_setting':	

						$settings = apply_filters( 'antsroute_delivery_setting', array(

							array(
								'type'     => 'select',
								'id'       => 'antsroute_delivery_time',
								'name'     => '',
								'options'  => $arr_deadline,
								'class'    => 'wc-enhanced-select',
								'desc' 	   => '',
								'default'  => '',
							),	
							
							array(
								'type'     => 'select',
								'id'       => 'antsroute_delivery_deadline',
								'name'     => '',
								'options'  => $arr_time,
								'class'    => 'wc-enhanced-select',
								'desc'	   => '',
								'default'  => '',
							),	
							array(
								'type' => 'sectionend',
								'id'   => 'group1_options'
							),							
														
							array(
								'name' => '',
								'type' => 'title',
								'desc' => '',
								'id'   => 'group2_options',
							),
						    
							array(
								'type'     => 'checkbox',
								'id'       => 'antsroute_monday_delivery_status',
								'name'     => '',
								'desc'     => '',
								'default'  => 'yes',
							),						    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_monday_delivery_start',					          
						          'description' => '',
						          'default' => '08:00',
						    ),							    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_monday_delivery_end',					          
						          'description' => '',
						          'default' => '10:00',
						    ),	
						    							
							array(
								'type'     => 'checkbox',
								'id'       => 'antsroute_tuesday_delivery_status',
								'name'     => '',
								'desc'     => '',
								'default'  => 'yes',
							),						    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_tuesday_delivery_start',					          
						          'description' => '',
						          'default' => '08:00',
						    ),							    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_tuesday_delivery_end',					          
						          'description' => '',
						          'default' => '10:00',
						    ),	
						    
						    
							array(
								'type'     => 'checkbox',
								'id'       => 'antsroute_wednesday_delivery_status',
								'name'     => '',
								'desc'     => '',
								'default'  => 'yes',
							),						    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_wednesday_delivery_start',					          
						          'description' => '',
						          'default' => '08:00',
						    ),							    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_wednesday_delivery_end',					          
						          'description' => '',
						          'default' => '10:00',
						    ),							    
						    
							array(
								'type'     => 'checkbox',
								'id'       => 'antsroute_thursday_delivery_status',
								'name'     => '',
								'desc'     => '',
								'default'  => 'yes',
							),						    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_thursday_delivery_start',					          
						          'description' => '',
						          'default' => '08:00',
						    ),							    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_thursday_delivery_end',					          
						          'description' => '',
						          'default' => '10:00',
						    ),							    
						    
							array(
								'type'     => 'checkbox',
								'id'       => 'antsroute_friday_delivery_status',
								'name'     => '',
								'desc'     => '',
								'default'  => 'yes',
							),						    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_friday_delivery_start',					          
						          'description' => '',
						          'default' => '08:00',
						    ),							    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_friday_delivery_end',					          
						          'description' => '',
						          'default' => '10:00',
						    ),							    
						    
							array(
								'type'     => 'checkbox',
								'id'       => 'antsroute_saturday_delivery_status',
								'name'     => '',
								'desc'     => '',
								'default'  => 'yes',
							),						    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_saturday_delivery_start',					          
						          'description' => '',
						          'default' => '08:00',
						    ),							    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_saturday_delivery_end',					          
						          'description' => '',
						          'default' => '10:00',
						    ),							    

							array(
								'type'     => 'checkbox',
								'id'       => 'antsroute_sunday_delivery_status',
								'name'     => '',
								'desc'     => '',
								'default'  => 'yes',
							),						    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_sunday_delivery_start',					          
						          'description' => '',
						          'default' => '08:00',
						    ),							    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_sunday_delivery_end',					          
						          'description' => '',
						          'default' => '10:00',
						    ),		
						) );
						
						return apply_filters( 'woocommerce_get_settings_' . $this->id, $settings, $current_section );

						break;

					case 'antsroute_pickup_setting':	
					
						$settings = apply_filters( 'antsroute_delivery_setting', array(

							array(
								'name' => __( 'Delivery option', 'ants-route' ) ,
								'type' => 'title',
								'desc' => '',
								'id'   => 'group1_options',
							),
					
							array(
								'type'     => 'select',
								'id'       => 'antsroute_enable_pickup',
								'name'     => '',
								'options'  => array(0 => 'No',
													1 => 'Yes'),
								'class'    => 'wc-enhanced-select',
								'desc' => '',
								'default'  => '',
							),	

							array(
						          'title' => '',
						          'type' => 'text',
								  'id'   => 'antsroute_deposit_address',					          
						          'description' => '',
						          'default' => ''
						    ),	

							array(
						          'title' => '',
						          'type' => 'text',
								  'id'   => 'antsroute_deposit_name',					          
						          'description' => '',
						          'default' => 'Dépot'
						    ),	

							array(
								'type'     => 'select',
								'id'       => 'antsroute_loading_time',
								'name'     => '',
								'options'  => $arr_time,
								'class'    => 'wc-enhanced-select',
								'desc'	   => '',
								'default'  => '',
							),	
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_loading_time_start',					          
						          'description' => '',
						          'default' => '08:00',
						    ),							    
							array(
						          'title' => '',
						          'type' => 'time',
								  'id'   => 'antsroute_loading_time_end',					          
						          'description' => '',
						          'default' => '11:30',
						    ),														    						    												
							array(
								'type' => 'sectionend',
								'id'   => 'group2_options'
							),						
						) );
						
						return apply_filters( 'woocommerce_get_settings_' . $this->id, $settings, $current_section );
						
						break;				
					}
				}							
			
			public function output() 
				{			        
			    global $current_section;
			    
				switch ($current_section)
					{
					case 'antsroute_general_setting':
//					case 'antsroute_pickup_setting':
					
						$settings = $this->get_settings( $current_section );
						 WC_Admin_Settings::output_fields( $settings );
						
						break;	

					case 'antsroute_pickup_setting':

						include ABSPATH . 'wp-content/plugins/Antsroute/partials/pickup_settings.php';
						break;
						
					case 'antsroute_delivery_setting':

					 	include ABSPATH . 'wp-content/plugins/Antsroute/partials/delivery_settings.php';
					 	break;
			
					case 'antsroute_log':
			
					 include ABSPATH . 'wp-content/plugins/Antsroute/partials/logs.php';
										
						break;	
	
					} 
			   	}


			public function save() 
				{
			    global $current_section;
			            
			    $settings = $this->get_settings( $current_section );
			    
			    WC_Admin_Settings::save_fields( $settings );			    
				}
				
				
				
				
			} // end class

		return new WC_Settings_AntsRoute();

		} // end function
		

		
		
	add_filter( 'woocommerce_get_settings_pages', 'my_plugin_add_settings', 15 );
	

	// redirect to first section when click on main tab
	add_action( 'woocommerce_settings_tabs', 'wc_settings_ants_route_tab' );
	
	function wc_settings_ants_route_tab() 
		{
		if ( isset($_GET['tab']) && $_GET['tab'] === 'antsroute' && !isset($_GET['section']))
	    	header('Location:admin.php?page=wc-settings&tab=antsroute&section=antsroute_general_setting');
		}



endif;	