<?php
	
/**
 * Displays log result in the WC Settings page
 */
	
	$GLOBALS['hide_save_button'] = true;
		
//echo "<pre>" .print_r($GLOBALS,true) . '</pre>';		

	if (!class_exists('WP_List_Table')) {
		require_once (ABSPATH . 'wp-admin/includes/class-wp-list-table.php');
	}	
	
	
	class log_Table extends WP_List_Table
	{
		public function __construct()
		{
			parent::__construct(array(
				'singular' => 'Log',
				'plural' => 'Logs',
				'ajax' => false
			));		
		}
		

		public static function get_records($per_page = 20, $page_number = 1)
		{
			global $wpdb;
			
			$sql = "select * from ".$wpdb->prefix."antsroute_logs";
	
			if (!empty($_REQUEST['orderby'])) {
				$sql.= ' ORDER BY ' . esc_sql($_REQUEST['orderby']);
				$sql.= !empty($_REQUEST['order']) ? ' ' . esc_sql($_REQUEST['order']) : ' DESC';
			}
			$sql.= " LIMIT $per_page";
			$sql.= ' OFFSET ' . ($page_number - 1) * $per_page;
			$result = $wpdb->get_results($sql, 'ARRAY_A');

			return $result;
			
			
		}		
		
			
		function get_columns()
		{
			$columns = [
				'cb' => '<input type="checkbox" />', 
				'date_send' => __('Date Sent', 'ants-route') , 
				'date_receive' => __('Date received', 'ants-route') , 
				'response_data' => __('Response Data', 'ants-route') , 
				'url' => __('URL', 'ants-route') , 
				'method' => __('Method', 'ants-route'),
				'params' => __('Params', 'ants-route'),
				'http_code' => __('HTTP code', 'ants-route'),
		
			];
			return $columns;
		}	
			
		public function get_hidden_columns()
		{
			
			array([
				'id' => __('id','ants-route')
			]);
			
			
			return array();
		}	
		
		public function get_sortable_columns()
		{
			$sortable_columns = array('http_code' => array('http_code',true),
									  'method' => array('method',true),
									  'date_send' => array('date_send',true),
									  'date_receive' => array('date_receive',true),
			);
			return $sortable_columns;
		}	
		
		public function column_default( $item, $column_name ) 
		{
			switch ( $column_name ) {
				case 'date_send':
				case 'date_receive':
				case 'method':
				case 'params':
				case 'http_code':
				case 'url':
				case 'response_data':
					return $item[ $column_name ];
				default:
					return print_r( $item, true );
			}
		}	
		
		function column_cb($item)
		{
			return sprintf('<input type="checkbox" name="bulk-delete[]" value="%s" />', $item['id']);
		}	
		
		
		public function get_bulk_actions()
		{
			$actions = ['bulk-delete' => __('Delete','ants-route')];
			return $actions;
		}	
		
		public static function delete_records($id)
		{
			global $wpdb;
			$wpdb->delete($wpdb->prefix."antsroute_logs", ['id' => $id], ['%d']);
		}	
		
		public static function record_count()
		{
			global $wpdb;
			$sql = "SELECT COUNT(*) FROM ".$wpdb->prefix."antsroute_logs";
			return $wpdb->get_var($sql);
		}
		
		public function no_items()
		{
			_e('No record found in the database.', 'ants-route');
		}	
		
		
		
		public function process_bulk_action() 
		{
			if ( 'delete' === $this->current_action() ) {	    
				self::delete_records( absint( $_GET['record'] ) );
			}
			if ( ( isset( $_POST['action'] ) && $_POST['action'] == 'bulk-delete' ) || ( isset( $_POST['action2'] ) && $_POST['action2'] == 'bulk-delete' )) {
				$delete_ids = esc_sql( $_POST['bulk-delete'] );
				foreach ( $delete_ids as $id ) {
					echo "<br>suppression de $id";
					self::delete_records( $id );
				}
			}
		}	
				
		public function prepare_items()
		{
			$columns = $this->get_columns();
			$hidden = $this->get_hidden_columns();
			$sortable = $this->get_sortable_columns();
			$this->_column_headers = array( $columns, $hidden, $sortable );
			$this->process_bulk_action();
			$per_page = $this->get_items_per_page('records_per_page', 50);
			$current_page = $this->get_pagenum();
			$total_items = self::record_count();
			$data = self::get_records($per_page, $current_page);
			$this->set_pagination_args( [
				'total_items' => $total_items,
				'per_page' => $per_page,
			]);
			$this->items = $data;
		}			
				
		
		
	} // end class log_Table
	

	
	$logs = new log_Table;
	echo '<form method="post">';
	$logs->prepare_items();
	$logs->search_box(__('Search Records', 'ants-route'), 'search_record');
	$logs->display();
	echo '</form>';
	
?>